import Channel from "./Channel";
import VideoCompact from "./VideoCompact";
interface PlaylistAttributes {
    id: string;
    title: string;
    videoCount: number;
    viewCount: number;
    lastUpdatedAt: string;
    channel?: Channel;
    videos: VideoCompact[];
}
export default class Playlist implements PlaylistAttributes {
    id: string;
    title: string;
    videoCount: number;
    viewCount: number;
    lastUpdatedAt: string;
    channel?: Channel;
    videos: VideoCompact[];
    constructor(playlist?: Partial<Playlist>);
    /**
     * Load instance attributes from youtube raw data
     *
     * @param youtubeRawData raw object from youtubei
     */
    load(youtubeRawData: any): Promise<this>;
    /**
     * Get compact videos
     *
     * @param playlistContents raw object from youtubei
     */
    private getVideos;
    /**
     * Load videos continuation
     *
     * @param continuation Continuation token
     */
    private getVideoContinuation;
    private getSideBarInfo;
}
export {};
