import Channel from "./Channel";
interface VideoCompactAttributes {
    id: string;
    title: string;
    duration: number | null;
    thumbnail: string;
    isLiveContent: boolean;
    channel?: Channel;
    uploadDate?: string;
    viewCount?: number;
    type: "video";
}
export default class VideoCompact implements VideoCompactAttributes {
    id: string;
    title: string;
    duration: number | null;
    thumbnail: string;
    isLiveContent: boolean;
    channel?: Channel;
    uploadDate?: string;
    viewCount?: number;
    type: "video";
    constructor(videoCompact?: Partial<VideoCompactAttributes>);
    /**
     * Load instance attributes from youtube raw data
     *
     * @param youtubeRawData raw object from youtubei
     */
    load(youtubeRawData: any): this;
    get isPrivateOrDeleted(): boolean;
}
export {};
